#!/usr/local/bin/bash
# Setup HLS-Proxy for FreeBSD
#

if [ ! -f hls-proxy ]; then
    echo "You should run install.sh from a directory of hls-proxy."
    echo "Interrupted"
    exit
fi


IS_MONIT_INSTALLED=$(which monit)

if [ "$IS_MONIT_INSTALLED" = "" ]; then

    # Install monit
    sudo pkg install -y monit

    # Enable monit run on boot
    sudo sysrc monit_enable=yes

fi

install1 () {

# Create monit conf file for HLS-Proxy

sudo -E bash -c 'cat >$MONITCONF <<EOL
check process hls-proxy
   matching "^HLS-Proxy "
   start program = "/bin/sh -c '\'$EXECUTABLE\''&" with timeout 10 seconds
   stop program = "/usr/bin/pkill hls-proxy"
EOL'


if [ ! -f "$MONITRC" ]; then

   sudo -E bash -c 'cat >$MONITRC <<EOL
set daemon 20

set logfile /var/log/monit.log

EOL'

    sudo chmod 700 $MONITRC
fi


# Clean monitrc from previous install
sudo sed -i '' '/monit-hls-proxy/d' $MONITRC

# Append new monit conf to monitrc

sudo -E bash -c 'echo "include $MONITCONF" >> $MONITRC'

if [ "$IS_MONIT_INSTALLED" = "" ]; then
    # Start monit
    sudo service monit start
else
    # Restart monit
    sudo service monit restart
    sudo pkill hls-proxy
fi

}

uninstall1 () {
# Clean monitrc from previous install
sudo sed -i '' '/monit-hls-proxy/d' $MONITRC
sudo rm $MONITCONF

# Restart monit
sudo service monit restart
sudo pkill hls-proxy
}

help () {

    echo
    echo Usage:
    echo      ./install.sh [options]
    echo
    echo Options:
    echo      u - uninstall \(stop and remove from autostart\)
#    echo      s - status \(and last log messages\)
    echo      h - this help

}

EXECUTABLE=$(pwd)/hls-proxy
MONITRC=/usr/local/etc/monitrc
MONITCONF=$(pwd)/monit-hls-proxy.conf

export MONITCONF
export MONITRC

if [ "$1" = "U" -o "$1" = "u" ]; then
    uninstall1
#    reloaddaemon
#elif [ "$1" = "S" -o "$1" = "s" ]; then
#    status
elif [ "$1" = "H" -o "$1" = "h" ]; then
    help
else
    install1
    help
fi

unset MONITRC
unset MONITCONF
